
/* ====================================================================
 * The Tata Infotech Software License, Version 1.0 
 * 
 * Copyright (c) 2002 Tata Infotech Ltd.  All rights reserved.
 * 
 * Redistribution and/or use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 * 
 * 3. The names "Tata Infotech Ltd.", and "SIP based Residential Gateway"
 *    must not be used to endorse or promote products derived from this
 *    software without prior written permission. For written permission,
 *    please contact atg.voip@tatainfotech.com
 * 
 * 4. Products derived from this software may not be called "SIP based
 *    Residential Gateway", nor may "SIP based Residential Gateway" appear
 *    in their name, without prior written permission of Tata Infotech Ltd.
 * 
 * THIS SOFTWARE IS PROVIDED "AS IS" WITHOUT ANY WARRANTY WHATSOEVER AND ANY
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE, TITLE AND NON-INFRINGEMENT
 * ARE DISCLAIMED.  
 * 
 * IN NO EVENT SHALL TATA INFOTECH LTD.  OR ITS CONTRIBUTORS BE LIABLE FOR ANY
 * DIRECT,  INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 * 
 * ====================================================================
 * 
 * This software consists of voluntary contributions made by Tata Infotech Ltd.
 * For more information on Tata Infotech Ltd.,  please see
 * <http://www.tatainfotech.com>.
 *
 */

static const char *const FormatSupportCheck_cxx_Version =
    "$Id: FormatSupportCheck.cxx,v 1.2 2002/04/05 08:07:41 manish Exp $";

#include <cassert>

#include <rtpTypes.h>

#include "FormatSupportCheck.hxx"

///
FormatSupportCheck *
    FormatSupportCheck::formatSupportCheck =
    0;

///
FormatSupportCheck *
FormatSupportCheck::instance()
{
    assert(formatSupportCheck != 0);
    return formatSupportCheck;
}

///
void
FormatSupportCheck::instance(int x)
{
    assert(formatSupportCheck == 0);

    formatSupportCheck = new FormatSupportCheck;
    assert(formatSupportCheck != 0);

}

///
FormatSupportCheck::FormatSupportCheck()
{
}

///
int
FormatSupportCheck::FormatSupportedOnHardware(int rtpPayloadType)
{
    int returnValue = 0;

    switch (rtpPayloadType)
    {
        case rtpPayloadPCMU:
            returnValue = 1;
            break;
        case rtpPayloadG723:
            returnValue = 1;
            break;
        default:
            returnValue = 0;
    }
    return (returnValue);
}

///
int
FormatSupportCheck::FormatSupportedOnSoftware(int rtpPayloadType)
{
    int returnValue = 0;

    switch (rtpPayloadType)
    {
        case rtpPayloadG726_32:
            returnValue = 1;
            break;
        default:
            returnValue = 0;
    }
    return (returnValue);
}

FormatSupportCheck::~FormatSupportCheck()
{
}
