static const char *const version =
/* ====================================================================
 * The Tata Infotech Software License, Version 1.0 
 * 
 * Copyright (c) 2002 Tata Infotech Ltd.  All rights reserved.
 * 
 * Redistribution and/or use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 * 
 * 3. The names "Tata Infotech Ltd.", and "SIP based Residential Gateway"
 *    must not be used to endorse or promote products derived from this
 *    software without prior written permission. For written permission,
 *    please contact atg.voip@tatainfotech.com
 * 
 * 4. Products derived from this software may not be called "SIP based
 *    Residential Gateway", nor may "SIP based Residential Gateway" appear
 *    in their name, without prior written permission of Tata Infotech Ltd.
 * 
 * THIS SOFTWARE IS PROVIDED "AS IS" WITHOUT ANY WARRANTY WHATSOEVER AND ANY
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE, TITLE AND NON-INFRINGEMENT
 * ARE DISCLAIMED.  
 * 
 * IN NO EVENT SHALL TATA INFOTECH LTD.  OR ITS CONTRIBUTORS BE LIABLE FOR ANY
 * DIRECT,  INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 * 
 * ====================================================================
 * 
 * This software consists of voluntary contributions made by Tata Infotech Ltd.
 * For more information on Tata Infotech Ltd.,  please see
 * <http://www.tatainfotech.com>.
 *
 */

    "$Id: gwOpAddDigit.cxx,v 1.2 2002/04/05 08:07:42 manish Exp $";

#include "RgDeviceEvent.hxx"
#include "RgDevice.hxx"

#include "gwOpAddDigit.hxx"

///
gwOpAddDigit::gwOpAddDigit()
{
}

///
gwOpAddDigit::~gwOpAddDigit()
{
}

///
const char *const
gwOpAddDigit::name() const
{
    return "gwOpAddDigit";
}

//***************************************************************************
//      gwOpAddDigit::process
//
//      Description     : 
//      This is the operator for gwStateIPDialing. 
//      For a PSTN->IP call, it performs the following functions:
//      (1) Accept the IP extension from the PSTN user
//
//***************************************************************************
const Sptr < State >
gwOpAddDigit::process(const Sptr < SipProxyEvent > event)
{
    cpLog(LOG_DEBUG, "gwOpAddDigit operation");

    Sptr < RgDeviceEvent > deviceEvent;
    deviceEvent.dynamicCast(event);
    if (deviceEvent == 0)
    {
        return 0;
    }

    char digit = ' ';

    cpLog(LOG_DEBUG, "deviceEvent->type=%d", deviceEvent->type);
    switch (deviceEvent->type)
    {
        case DeviceEventPSTNDtmfStar:
            {
                digit = '*';
            }
            break;
        case DeviceEventPSTNDtmfHash:
            {
                digit = '#';
            }
            break;
        case DeviceEventPSTNDtmf0:
            {
                digit = '0';
            }
            break;
        case DeviceEventPSTNDtmf1:
            {
                digit = '1';
            }
            break;
        case DeviceEventPSTNDtmf2:
            {
                digit = '2';
            }
            break;
        case DeviceEventPSTNDtmf3:
            {
                digit = '3';
            }
            break;
        case DeviceEventPSTNDtmf4:
            {
                digit = '4';
            }
            break;
        case DeviceEventPSTNDtmf5:
            {
                digit = '5';
            }
            break;
        case DeviceEventPSTNDtmf6:
            {
                digit = '6';
            }
            break;
        case DeviceEventPSTNDtmf7:
            {
                digit = '7';
            }
            break;
        case DeviceEventPSTNDtmf8:
            {
                digit = '8';
            }
            break;
        case DeviceEventPSTNDtmf9:
            {
                digit = '9';
            }
            break;

            // TODO add 'A', 'B', 'C' and 'D'
        default:
            {
                cpLog(LOG_DEBUG, "Not a digit");
            }

    }                                   //End of switch

    if (digit != ' ')
    {
        cpLog(LOG_DEBUG, "Add Digit %c", digit);
        cout << digit << flush;
        RgDevice::instance()->getDigitCollector()->addDigit(digit);
    }
    return 0;
}
